Attribute VB_Name = "RenderMod"
Public Function Render()
   
    D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0  '//Clear the screen black
    
    D3DDevice.LightEnable 0, True
    D3DDevice.LightEnable 1, True
    D3DDevice.LightEnable 2, True
    
    'any rendering you are going to do needs to be withen the begin}~~~{end scene tags
    D3DDevice.BeginScene
        
        'draw the worldmesh which happens to be our land scape and place it right in the middle of every thing
        RenderMesh WorldMesh(0), 0, 0, 0
        
        For w = 0 To UBound(TreeMesh) 'draw all of our trees and place them at there set postitions
            RenderMesh TreeMesh(w), TreeMesh(w).MX, TreeMesh(w).MY, TreeMesh(w).MZ
        Next w
        For w = 0 To UBound(HouseMesh) 'draw all of our house objects
            RenderMesh HouseMesh(w), HouseMesh(w).MX, HouseMesh(w).MY, HouseMesh(w).MZ
        Next w
        For w = 0 To UBound(RoadMesh) 'draw our road objects
            RenderMesh RoadMesh(w), RoadMesh(w).MX, RoadMesh(w).MY, RoadMesh(w).MZ
        Next w
        
        MyMartixSetUp   'pretty self explanatory
        
        'create a rectangle to draw the text in
        With TextRect(0)
            .Top = 1
            .bottom = 200
            .Left = 1
            .Right = 180
        End With
        
        'draw the text to screen - most people use this to display the frame rate
        D3DX.DrawText D3DFont, &HFFFFCC00, "SavageVB's 3D Demo :" & vbCrLf & vbCrLf & "X : " & CAMX & vbCrLf & "Y : " & CAMY & vbCrLf & "Z : " & CAMZ, TextRect(0), DT_TOP Or DT_CENTER
        
    D3DDevice.EndScene 'end the render scene
    
    D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Function
Private Sub MyMartixSetUp() 'i couldn't come up with any original names
    Dim matLook As D3DMATRIX
    Dim matRotation As D3DMATRIX
    
    D3DXMatrixIdentity matLook
    D3DXMatrixIdentity matRotation
    
    'check if any keys have or are being pressed
    DKIDevice.GetDeviceStateKeyboard DKIState
    
    If DKIState.Key(205) <> 0 Then  'if the right button is being pressed
        Angle = Angle - TSPEED
        If Angle < 0 Then Angle = D_360 - (-Angle)
    End If

    If DKIState.Key(203) <> 0 Then  'if the left button is being pressed
        Angle = Angle + TSPEED
        If Angle > D_360 Then Angle = 0 + (Angle - D_360)
    End If
    
    ConvAngle = D_360 - Angle
    
    If DKIState.Key(200) <> 0 Then
        CAMX = CAMX - (Sin(ConvAngle) * MSPEED)
        CAMY = CAMY + (Cos(ConvAngle) * MSPEED)
    End If
    
    If DKIState.Key(208) <> 0 Then
        CAMX = CAMX + (Sin(ConvAngle) * MSPEED)
        CAMY = CAMY - (Cos(ConvAngle) * MSPEED)
    End If
    
    CAMZ = 0
    
    SnowMesh(0).MX = -CAMX
    SnowMesh(0).MY = -CAMY
    SnowMesh(0).MAngle = ConvAngle + D_180
    
    'render the snowman
    RenderMesh SnowMesh(0), -SnowMesh(0).MX, -SnowMesh(0).MY, 0, SnowMesh(0).MAngle  ', SnowMesh(0).MAngle
    'move the camera to its new location
    'in this example z = up,down y = back,forward and x = left,right
    D3DXMatrixTranslation matLook, -CAMX, -CAMY + 75, -CAMZ - 75
    D3DXMatrixMultiply matLook, matLook, matView
    'set the camera view to aim diagonally down towards the snowman
    D3DXMatrixRotationX matRotation, -0.55
    D3DXMatrixMultiply matLook, matLook, matRotation
    D3DDevice.SetTransform D3DTS_VIEW, matLook

End Sub
Public Function RenderMesh(InMatrix As MyMesh, InX As Single, InY As Single, InZ As Single, Optional RAngle As Single = 0): Dim RenderTempMat As D3DMATRIX
    D3DXMatrixIdentity RenderTempMat
    D3DXMatrixIdentity InMatrix.Matrix
    'rotate the 3d object on the Z axis by 'rangle'
    D3DXMatrixRotationZ InMatrix.Matrix, RAngle
    D3DXMatrixMultiply RenderTempMat, RenderTempMat, InMatrix.Matrix
    'move the 3d object to inx,iny,inz
    D3DXMatrixTranslation InMatrix.Matrix, InX, InY, InZ
    D3DXMatrixMultiply RenderTempMat, RenderTempMat, InMatrix.Matrix
    D3DDevice.SetTransform D3DTS_WORLD, RenderTempMat
    'for each of the 3d object, objects
    For I = 0 To InMatrix.MCount - 1
        D3DDevice.SetMaterial InMatrix.Mat(I)   'set the object
        D3DDevice.SetTexture 0, InMatrix.Tex(I) 'set the texture
        InMatrix.Mesh.DrawSubset I              'draw object
    Next
End Function
